#include <signal.h>

void wfcHandler(int n)
{
   printf("\nSIGFPE: Divide by zero.\n");
}

int main(int argc, char *argv)
{
   register int fpsr;  
   float f1, f2, f3;
 
   if (argc > 1)
   {
      __asm__("rfs %0" : : "g" (fpsr));
      printf("before: fpsr = 0x%08x\n",fpsr);

      __asm__("rfs %0;
               orr %0, %0, #0x00020000;
               wfs %0;
               rfs %0" 
               : /* no outputs */
               : "g" (fpsr));
      printf("after: fpsr written and reread = 0x%08x\n",fpsr);
      signal(SIGFPE,wfcHandler);
   }
   
   f1 = 1.0;
   f2 = 0.0;
   f3 = f1 / f2;   
   
   //printf("\nAbout to do raise(SIGFPE)\n");
   //raise(SIGFPE);
} 